Subject: [lmap] Consider constraints for MA capabilities (lmap-information-model)

From: Holger Wiehen <[email-masked]>
Date: Thu, 24 Sep 2015 13:51:46 -0300

Hi.

Following is a suggestion to extend the concept of MA capabilities. Maybe it is on time for the interim?

The capabilities of a MA might include constraints, for the measurement tasks it supports. The Controller should consider those constraints when it instructs the MA. Constraints might limit the Controller’s choice for task-options or for task scheduling.

Three examples:
- A measurement agent does support a given measurement task, but due to limited device resources, the task configuration should respect a maximum duration.
- A measurement agent is deployed at an office location. Measurements should occur after office hours, only. 
- A large scale measurement network is deployed across multiple autonomous systems. The participating organisations can decide if they allow tests  crossing AS bounderies.

In the list archive, it was mentioned that the ma-task-capability-obj will be reintroduced. Constraints could be an optional atribute of this object:

 object {
 	string ma-task-name;
 	uri ma-task-registry;
 	string ma-task-role;
	[ ma-capability-task-constraint-obj ma-capability-task-constraints<0..*> ]
	[ ma-capability-schedule-constraint-obj ma-capability-schedule-constraints<0..*> ]
 } ma-task-capability-obj;

object {
	string ma-option-name;
	[ object ma-option-value-set<0..*>; ]
	[ object ma-option-value-range-start; ]
	[ object ma-option-value-range-end; ]
} ma-capability-task-constraint-obj 

In this case the constraint applies to a task’s configuration. The constraint explicitly enumerates the allowed task-option values, or specifies a range of allowed task-option values, given a lower and/or upper bound.
  
A constraint on task scheduling will be more complex to model.

What do you think about the notion of constraints, when announcing capabilities of a MA?

Regards,

Holger Wiehen.

---

From: "Romascanu, Dan (Dan)" <[email-masked]>
Date: Sun, 27 Sep 2015 07:59:44 +0000

Hi Holger,

We can discuss this indeed at the virtual interim (part of the IM discussions)

Regards,

Dan

From: lmap [mailto:[email-masked]] On Behalf Of Holger Wiehen
Sent: Thursday, September 24, 2015 7:52 PM
To: [email-masked]
Cc: Juergen Schoenwaelder
Subject: [lmap] Consider constraints for MA capabilities (lmap-information-model)

Hi.

Three examples:

 object {
          string ma-task-name;
          uri ma-task-registry;
          string ma-task-role;

object {
          string ma-option-name;

Regards,

Holger Wiehen.

---

From: Juergen Schoenwaelder <[email-masked]>
Date: Mon, 28 Sep 2015 09:19:04 +0200

Holger,

I believe the WGs goal should be deliver a base model and to leave
additional features to future extension. I think we should avoid
feature creep.

So the questions to ask are:

- Is this something that can be found on a significant number of
  probes deployed today?
- Can this be defined as an extension of the information model or
  does it have to be in the core LMAP information model?

/js

-- 
Juergen Schoenwaelder           Jacobs University Bremen gGmbH
Phone: +49 421 200 3587         Campus Ring 1 | 28759 Bremen | Germany
Fax:   +49 421 200 3103         <http://www.jacobs-university.de/>

---

From: Holger Wiehen <[email-masked]>
Date: Mon, 28 Sep 2015 09:12:36 -0300

Jürgen,

> On Sep 28, 2015, at 4:19 AM, Juergen Schoenwaelder <[email-masked]> wrote:
> 
> Holger,
> 

I agree it will be beneficial to leave “capability constraints” to an extension if the typical use case does not depend on it.

> - Is this something that can be found on a significant number of

Maybe the WG could comment on that. 

>  does it have to be in the core LMAP information model?

My impression is that the notion of constraints is inherent to the concept of capabilities. So it seemed to me like a conceptual hole.
I understand a capability as the ability to perform a given measurement task within a range of supported configurations. 

RFC7594 states in section 5.2.2 that LMAP does not consider task negotiation between MA e Controller. The announcement of “capability constraints” would be coherent with this restriction. It would be a one way information, just like the proper capability. 

Thank’s

Holger Wiehen.